//
//  AppDelegate.m
//  XXXDAOTest
//
//  Created by SQLite+ on 03/09/2014
//  Copyright (c) http://www.iosxtools.com All rights reserved.
//

#import "AppDelegate.h"
#import "XXXDBManager.h"
#import "LibCategoryDAO.h"
#import "LibCategory.h"
@implementation AppDelegate

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // Insert code here to initialize your application
    
    /*open database in your porject bundle resource*/
    [[XXXDBManager sharedXXXDBManager]openDataBaseInBundle:@"SQLiteDemo.sqlite"];
    
    /*or open database in your app path*/
    /*NSString *path = [[self appPath]stringByAppendingPathComponent:@"SQLiteDemo.sqlite"];
    [[XXXDBManager sharedXXXDBManager]openDataBaseWithPath:path];
    */
    
    LibCategoryDAO *dao = [[LibCategoryDAO alloc]init];
    
    /*query all record*/
    NSArray *items = [dao findAll];
    NSLog(@"items count=%ld",[items count]);
    for(LibCategory *category in items){
        NSLog(@"category=%@",category);
    }
    
    /*query record by attributes(name=you) */
    items = [dao findByAttributes:@{@"name":@"you",@"order":@(3)}];
    NSLog(@"items count=%ld",[items count]);
    for(LibCategory *category in items){
        NSLog(@"category=%@",category);
    }
    
    /*query record by attributes(name=you and order=3) */
    items = [dao findByAttributes:@{@"name":@"you",@"order":@(3)}];
    NSLog(@"items count=%ld",[items count]);
    for(LibCategory *category in items){
        NSLog(@"category=%@",category);
    }
    
    
    /*query record by sql */
    items = [dao sqlQuery:@"select * from LibCategory where order > 4"];
    NSLog(@"items count=%ld",[items count]);
    for(LibCategory *category in items){
        NSLog(@"category=%@",category);
    }
        
    /*fetch records based on the index of pages*/
    items = [dao findByPage:1 pageSize:20];
    NSLog(@"items count=%ld",[items count]);
    for(LibCategory *category in items){
        NSLog(@"category=%@",category);
    }
    
    /*
     primary key fetech
     */
    
    /*1.query record by primary key ID=1*/
    LibCategory *category1 = [dao findByKey:@{@"ID":@(1)}];
    
    
    /*2. query record by category modle ID=1*/
    LibCategory *category = [[LibCategory alloc]init];
    category.ID = 1;
    LibCategory *category2 = [dao findByKey:category];
    
    /*
     record insert
     */
    LibCategory *category3 = [[LibCategory alloc]init];
    category3.ID =2;
    category3.name = @"IOS";
    category3.order = 1;
    [dao insert:category3];
    
    
    /*
     record update
     */
    category3.order = 6;
    [dao update:category3];
    
    /*
     record delete
     */
    [dao delete:category3];
    
    /**/
    
    
}


- (NSString*)appPath{
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDirectory = [paths objectAtIndex:0];
    return documentsDirectory;
}

@end
