/*
 Library.m
 
 Created by  on 05/03/2014 04:25AM.
 Copyright (c) 2013 . All rights reserved.
 */
#import "Library.h"
@implementation Library
/*init property member var by parsing NSDictionary parameter*/
- (id)initWithDictionary:(NSDictionary *)dictionary{
	if ((self = [super init]) && (dictionary))
	{
        id value ;
        value = dictionary[@"ID"];
        if(value) _ID = [value longValue];  

        value = dictionary[@"framework"];
        if(value) _framework = value;  

        value = dictionary[@"title"];
        if(value) _title = value;  

        value = dictionary[@"description"];
        if(value) _description = value;  

        value = dictionary[@"date"];
        if(value) _date = value;  

        value = dictionary[@"sortOrder"];
        if(value) _sortOrder = [value longValue];  

        value = dictionary[@"fileName"];
        if(value) _fileName = value;  

        value = dictionary[@"codePath"];
        if(value) _codePath = value;  

        value = dictionary[@"isUnZipped"];
        if(value) _isUnZipped = [value boolValue];

  
    }
    return self;  
}               
- (id)initWithCoder:(NSCoder *)coder{
	if ((self = [super init]))
	{
    	if ([coder allowsKeyedCoding])
	    {
            _ID = [coder decodeIntegerForKey:@"ID"];
            _framework = [coder decodeObjectForKey:@"framework"];  
            _title = [coder decodeObjectForKey:@"title"];  
            _description = [coder decodeObjectForKey:@"description"];  
            _date = [coder decodeObjectForKey:@"date"];  
            _sortOrder = [coder decodeIntegerForKey:@"sortOrder"];
            _fileName = [coder decodeObjectForKey:@"fileName"];  
            _codePath = [coder decodeObjectForKey:@"codePath"];  
            _isUnZipped = [coder decodeBoolForKey:@"isUnZipped"];
        }
        else
        {
            _ID = [[coder decodeObject]longValue];
            _framework = [coder decodeObject];  
            _title = [coder decodeObject];  
            _description = [coder decodeObject];  
            _date = [coder decodeObject];  
            _sortOrder = [[coder decodeObject]longValue];
            _fileName = [coder decodeObject];  
            _codePath = [coder decodeObject];  
            _isUnZipped = [[coder decodeObject]boolValue];
        
        }
    }
    return self;
}
- (void)encodeWithCoder:(NSCoder *)coder {
	if ([coder allowsKeyedCoding])
	{
        [coder encodeInt64:_ID forKey:@"ID"];
        if(_framework) [coder encodeObject:_framework forKey:@"framework"];
        if(_title) [coder encodeObject:_title forKey:@"title"];
        if(_description) [coder encodeObject:_description forKey:@"description"];
        if(_date) [coder encodeObject:_date forKey:@"date"];
        [coder encodeInt64:_sortOrder forKey:@"sortOrder"];
        if(_fileName) [coder encodeObject:_fileName forKey:@"fileName"];
        if(_codePath) [coder encodeObject:_codePath forKey:@"codePath"];
        [coder encodeBool:_isUnZipped forKey:@"isUnZipped"];
    }
    else
    {
        [coder encodeValueOfObjCType:@encode(long) at:&_ID];
        if(_framework) [coder encodeObject:_framework];
        if(_title) [coder encodeObject:_title];
        if(_description) [coder encodeObject:_description];
        if(_date) [coder encodeObject:_date];
        [coder encodeValueOfObjCType:@encode(long) at:&_sortOrder];
        if(_fileName) [coder encodeObject:_fileName];
        if(_codePath) [coder encodeObject:_codePath];
        [coder encodeValueOfObjCType:@encode(BOOL) at:&_isUnZipped];
    
    }
}
- (BOOL)isEqual:(Library *)obj {
    if(![obj isKindOfClass:Library.class])
    { 
        return NO;
    }
    return (self.ID==obj.ID)
    && ([self.framework isEqual:obj.framework])
    && ([self.title isEqual:obj.title])
    && ([self.description isEqual:obj.description])
    && ([self.date isEqual:obj.date])
    && (self.sortOrder==obj.sortOrder)
    && ([self.fileName isEqual:obj.fileName])
    && ([self.codePath isEqual:obj.codePath])
    && (self.isUnZipped==obj.isUnZipped)
    ;
}
- (NSDictionary*)JSONKeyPathsByPropertyKey
{
    return nil;
}
-(BOOL) allowsKeyedCoding
{
    /*[self setValuesForKeysWithDictionary:jsonObject];*/
	return YES;
}
- (id)valueForUndefinedKey:(NSString *)key
{
    // subclass implementation should provide correct key value mappings for custom keys
    NSLog(@"Undefined Key: %@", key);
    return nil;
}

- (void)setValue:(id)value forUndefinedKey:(NSString *)key
{
    // subclass implementation should set the correct key value mappings for custom keys
    NSLog(@"Undefined Key: %@", key);
}
@end
